#include "..\C-Engine\CHeader.hpp"

#include "Koopa.hpp"

void IaKoopa::Start()
{
    direction = 1;
    shell = false;
    time = 0;
}

void IaKoopa::UpdateEverySecond()
{
    if(shell)time ++;
    if(time > 5)
    {
        shell = false;
        time = 0;
    }
}

void IaKoopa::Update()
{

    if(!shell)
    {
        if(GetObject()->GetRigibody()->CollisionDecor(GetX() + 1,GetY()) || !GetObject()->GetRigibody()->CollisionDecor(GetX() + 1,GetY() - 1))direction = 2;
        if(GetObject()->GetRigibody()->CollisionDecor(GetX() - 1,GetY()) || !GetObject()->GetRigibody()->CollisionDecor(GetX() - 1,GetY() - 1))direction = 1;

        switch(direction)
        {
            case 1 : Move(1,0); break;
            case 2 : Move(-1,0); break;
            default : break;
        }

        GetObject()->GetRender()->ReverseRender(!(direction - 1));

        SetIt(0);

        Object * Buffer = GetObject()->CollisionTagO("J1");
        if(Buffer != NULL)
        {

            if(Buffer->GetTransforms()->GetY() > GetY() + 8)
            {
                shell = true;
                direction = 0;

                if(Buffer->GetTransforms()->GetX() + 8 < GetX() + 3 )direction = 1;
                if(Buffer->GetTransforms()->GetX() + 8 > GetX() + 6 )direction = 2;

                Buffer->GetRigibody()->GetBody()->velocity.y = 0;
            }
        }

    }
    else
    {
        if(GetObject()->GetRigibody()->CollisionDecor(GetX() + 1,GetY()))direction = 2;
        if(GetObject()->GetRigibody()->CollisionDecor(GetX() - 1,GetY()))direction = 1;

        switch(direction)
        {
            case 1 : Move(3,0); break;
            case 2 : Move(-3,0); break;
            default : break;
        }

        SetIt(1);

        Object * Buffer = GetObject()->CollisionTagO("J1");
        if(Buffer != NULL)
        {
            shell = true;
            direction = 0;

            if(Buffer->GetTransforms()->GetX() + 8 < GetX() + 3 )direction = 1;
            if(Buffer->GetTransforms()->GetX() + 8 > GetX() + 6 )direction = 2;

            Buffer->GetRigibody()->GetBody()->velocity.y = 0;
        }
    }
}
