#include "..\C-Engine\CHeader.hpp"

#include "Goomba.hpp"

void IaGoomba::Start()
{
    direction = 1;
}

void IaGoomba::Update()
{

    if(GetObject()->GetRigibody()->CollisionDecor(GetX() + 1,GetY()) || !GetObject()->GetRigibody()->CollisionDecor(GetX() + 1,GetY() - 1))direction = 2;
    if(GetObject()->GetRigibody()->CollisionDecor(GetX() - 1,GetY()) || !GetObject()->GetRigibody()->CollisionDecor(GetX() - 1,GetY() - 1))direction = 1;

    switch(direction)
    {
        case 1 : Move(1,0); break;
        case 2 : Move(-1,0); break;
        default : break;
    }

    Object * Buffer = GetObject()->CollisionTagO("J1");
    if(Buffer != NULL)
    {

        if(Buffer->GetTransforms()->GetY() > GetY() + 8)
        {
            GetEngine()->DelObject(GetObject());
        }
    }
}
